Index: src/includes/classes/Smarty/sysplugins/smarty_internal_method_append.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_method_append.php	(revision )
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_method_append.php	(revision )
@@ -0,0 +1,74 @@
+<?php
+
+/**
+ * Smarty Method Append
+ *
+ * Smarty::append() method
+ *
+ * @package    Smarty
+ * @subpackage PluginsInternal
+ * @author     Uwe Tews
+ */
+class Smarty_Internal_Method_Append
+{
+    /**
+     * Valid for all objects
+     *
+     * @var int
+     */
+    public $objMap = 7;
+
+    /**
+     * appends values to template variables
+     *
+     * @api  Smarty::append()
+     * @link http://www.smarty.net/docs/en/api.append.tpl
+     *
+     * @param \Smarty_Internal_Data|\Smarty_Internal_Template|\Smarty $data
+     * @param  array|string                                           $tpl_var the template variable name(s)
+     * @param  mixed                                                  $value   the value to append
+     * @param  bool                                                   $merge   flag if array elements shall be merged
+     * @param  bool                                                   $nocache if true any output of this variable will
+     *                                                                         be not cached
+     *
+     * @return \Smarty_Internal_Data|\Smarty_Internal_Template|\Smarty
+     */
+    public function append(Smarty_Internal_Data $data, $tpl_var, $value = null, $merge = false, $nocache = false)
+    {
+        if (is_array($tpl_var)) {
+            // $tpl_var is an array, ignore $value
+            foreach ($tpl_var as $_key => $_val) {
+                if ($_key != '') {
+                    $this->append($data, $_key, $_val, $merge, $nocache);
+                }
+            }
+        } else {
+            if ($tpl_var != '' && isset($value)) {
+                if (!isset($data->tpl_vars[$tpl_var])) {
+                    $tpl_var_inst = $data->ext->getTemplateVars->_getVariable($data, $tpl_var, null, true, false);
+                    if ($tpl_var_inst instanceof Smarty_Undefined_Variable) {
+                        $data->tpl_vars[$tpl_var] = new Smarty_Variable(null, $nocache);
+                    } else {
+                        $data->tpl_vars[$tpl_var] = clone $tpl_var_inst;
+                    }
+                }
+                if (!(is_array($data->tpl_vars[$tpl_var]->value) ||
+                    $data->tpl_vars[$tpl_var]->value instanceof ArrayAccess)
+                ) {
+                    settype($data->tpl_vars[$tpl_var]->value, 'array');
+                }
+                if ($merge && is_array($value)) {
+                    foreach ($value as $_mkey => $_mval) {
+                        $data->tpl_vars[$tpl_var]->value[$_mkey] = $_mval;
+                    }
+                } else {
+                    $data->tpl_vars[$tpl_var]->value[] = $value;
+                }
+            }
+            if ($data->_objType == 2 && $data->scope) {
+                $data->ext->_updateScope->updateScope($data, $tpl_var);
+            }
+        }
+        return $data;
+    }
+}
\ No newline at end of file
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_compile_if.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_compile_if.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_compile_if.php	(revision )
@@ -19,13 +19,14 @@
     /**
      * Compiles code for the {if} tag
      *
-     * @param array  $args      array with attributes from parser
+     * @param array                                 $args      array with attributes from parser
-     * @param object $compiler  compiler object
+     * @param \Smarty_Internal_TemplateCompilerBase $compiler  compiler object
-     * @param array  $parameter array with compilation parameter
+     * @param array                                 $parameter array with compilation parameter
      *
      * @return string compiled code
+     * @throws \SmartyCompilerException
      */
-    public function compile($args, $compiler, $parameter)
+    public function compile($args, Smarty_Internal_TemplateCompilerBase $compiler, $parameter)
     {
         // check and get attributes
         $_attr = $this->getAttributes($compiler, $args);
@@ -34,7 +35,7 @@
         $compiler->nocache = $compiler->nocache | $compiler->tag_nocache;
 
         if (!array_key_exists("if condition", $parameter)) {
-            $compiler->trigger_template_error("missing if condition", $compiler->lex->taglineno);
+            $compiler->trigger_template_error("missing if condition", null, true);
         }
 
         if (is_array($parameter['if condition'])) {
@@ -42,19 +43,32 @@
                 $_nocache = ',true';
                 // create nocache var to make it know for further compiling
                 if (is_array($parameter['if condition']['var'])) {
-                    $compiler->template->tpl_vars[trim($parameter['if condition']['var']['var'], "'")] = new Smarty_variable(null, true);
+                    $var = trim($parameter['if condition']['var']['var'], "'");
                 } else {
-                    $compiler->template->tpl_vars[trim($parameter['if condition']['var'], "'")] = new Smarty_variable(null, true);
+                    $var = trim($parameter['if condition']['var'], "'");
                 }
+                if (isset($compiler->template->tpl_vars[$var])) {
+                    $compiler->template->tpl_vars[$var]->nocache = true;
-            } else {
+                } else {
+                    $compiler->template->tpl_vars[$var] = new Smarty_Variable(null, true);
+                }
+            } else {
                 $_nocache = '';
             }
             if (is_array($parameter['if condition']['var'])) {
-                $_output = "<?php if (!isset(\$_smarty_tpl->tpl_vars[" . $parameter['if condition']['var']['var'] . "]) || !is_array(\$_smarty_tpl->tpl_vars[" . $parameter['if condition']['var']['var'] . "]->value)) \$_smarty_tpl->createLocalArrayVariable(" . $parameter['if condition']['var']['var'] . "$_nocache);\n";
-                $_output .= "if (\$_smarty_tpl->tpl_vars[" . $parameter['if condition']['var']['var'] . "]->value" . $parameter['if condition']['var']['smarty_internal_index'] . " = " . $parameter['if condition']['value'] . ") {?>";
+                $_output = "<?php if (!isset(\$_smarty_tpl->tpl_vars[" . $parameter['if condition']['var']['var'] .
+                    "]) || !is_array(\$_smarty_tpl->tpl_vars[" . $parameter['if condition']['var']['var'] .
+                    "]->value)) \$_smarty_tpl->smarty->ext->_var->createLocalArrayVariable(\$_smarty_tpl, " . $parameter['if condition']['var']['var'] .
+                    "$_nocache);\n";
+                $_output .= "if (\$_smarty_tpl->tpl_vars[" . $parameter['if condition']['var']['var'] . "]->value" .
+                    $parameter['if condition']['var']['smarty_internal_index'] . " = " .
+                    $parameter['if condition']['value'] . ") {?>";
             } else {
-                $_output = "<?php if (!isset(\$_smarty_tpl->tpl_vars[" . $parameter['if condition']['var'] . "])) \$_smarty_tpl->tpl_vars[" . $parameter['if condition']['var'] . "] = new Smarty_Variable(null{$_nocache});";
-                $_output .= "if (\$_smarty_tpl->tpl_vars[" . $parameter['if condition']['var'] . "]->value = " . $parameter['if condition']['value'] . ") {?>";
+                $_output = "<?php if (!isset(\$_smarty_tpl->tpl_vars[" . $parameter['if condition']['var'] .
+                    "])) \$_smarty_tpl->tpl_vars[" . $parameter['if condition']['var'] .
+                    "] = new Smarty_Variable(null{$_nocache});";
+                $_output .= "if (\$_smarty_tpl->tpl_vars[" . $parameter['if condition']['var'] . "]->value = " .
+                    $parameter['if condition']['value'] . ") {?>";
             }
 
             return $_output;
@@ -75,13 +89,13 @@
     /**
      * Compiles code for the {else} tag
      *
-     * @param array  $args      array with attributes from parser
+     * @param array                                 $args      array with attributes from parser
-     * @param object $compiler  compiler object
+     * @param \Smarty_Internal_TemplateCompilerBase $compiler  compiler object
-     * @param array  $parameter array with compilation parameter
+     * @param array                                 $parameter array with compilation parameter
      *
      * @return string compiled code
      */
-    public function compile($args, $compiler, $parameter)
+    public function compile($args, Smarty_Internal_TemplateCompilerBase $compiler, $parameter)
     {
         list($nesting, $compiler->tag_nocache) = $this->closeTag($compiler, array('if', 'elseif'));
         $this->openTag($compiler, 'else', array($nesting, $compiler->tag_nocache));
@@ -101,13 +115,14 @@
     /**
      * Compiles code for the {elseif} tag
      *
-     * @param array  $args      array with attributes from parser
+     * @param array                                 $args      array with attributes from parser
-     * @param object $compiler  compiler object
+     * @param \Smarty_Internal_TemplateCompilerBase $compiler  compiler object
-     * @param array  $parameter array with compilation parameter
+     * @param array                                 $parameter array with compilation parameter
      *
      * @return string compiled code
+     * @throws \SmartyCompilerException
      */
-    public function compile($args, $compiler, $parameter)
+    public function compile($args, Smarty_Internal_TemplateCompilerBase $compiler, $parameter)
     {
         // check and get attributes
         $_attr = $this->getAttributes($compiler, $args);
@@ -115,7 +130,7 @@
         list($nesting, $compiler->tag_nocache) = $this->closeTag($compiler, array('if', 'elseif'));
 
         if (!array_key_exists("if condition", $parameter)) {
-            $compiler->trigger_template_error("missing elseif condition", $compiler->lex->taglineno);
+            $compiler->trigger_template_error("missing elseif condition", null, true);
         }
 
         if (is_array($parameter['if condition'])) {
@@ -124,11 +139,16 @@
                 $_nocache = ',true';
                 // create nocache var to make it know for further compiling
                 if (is_array($parameter['if condition']['var'])) {
-                    $compiler->template->tpl_vars[trim($parameter['if condition']['var']['var'], "'")] = new Smarty_variable(null, true);
+                    $var = trim($parameter['if condition']['var']['var'], "'");
                 } else {
-                    $compiler->template->tpl_vars[trim($parameter['if condition']['var'], "'")] = new Smarty_variable(null, true);
+                    $var = trim($parameter['if condition']['var'], "'");
                 }
+                if (isset($compiler->template->tpl_vars[$var])) {
+                    $compiler->template->tpl_vars[$var]->nocache = true;
-            } else {
+                } else {
+                    $compiler->template->tpl_vars[$var] = new Smarty_Variable(null, true);
+                }
+            } else {
                 $_nocache = '';
             }
         } else {
@@ -139,11 +159,20 @@
             if ($condition_by_assign) {
                 $this->openTag($compiler, 'elseif', array($nesting + 1, $compiler->tag_nocache));
                 if (is_array($parameter['if condition']['var'])) {
-                    $_output = "<?php } else { if (!isset(\$_smarty_tpl->tpl_vars[" . $parameter['if condition']['var']['var'] . "]) || !is_array(\$_smarty_tpl->tpl_vars[" . $parameter['if condition']['var']['var'] . "]->value)) \$_smarty_tpl->createLocalArrayVariable(" . $parameter['if condition']['var']['var'] . "$_nocache);\n";
-                    $_output .= "if (\$_smarty_tpl->tpl_vars[" . $parameter['if condition']['var']['var'] . "]->value" . $parameter['if condition']['var']['smarty_internal_index'] . " = " . $parameter['if condition']['value'] . ") {?>";
+                    $_output = "<?php } else { if (!isset(\$_smarty_tpl->tpl_vars[" .
+                        $parameter['if condition']['var']['var'] . "]) || !is_array(\$_smarty_tpl->tpl_vars[" .
+                        $parameter['if condition']['var']['var'] .
+                        "]->value)) \$_smarty_tpl->smarty->ext->_var->createLocalArrayVariable(\$_smarty_tpl, " .
+                        $parameter['if condition']['var']['var'] . "$_nocache);\n";
+                    $_output .= "if (\$_smarty_tpl->tpl_vars[" . $parameter['if condition']['var']['var'] . "]->value" .
+                        $parameter['if condition']['var']['smarty_internal_index'] . " = " .
+                        $parameter['if condition']['value'] . ") {?>";
                 } else {
-                    $_output = "<?php  } else { if (!isset(\$_smarty_tpl->tpl_vars[" . $parameter['if condition']['var'] . "])) \$_smarty_tpl->tpl_vars[" . $parameter['if condition']['var'] . "] = new Smarty_Variable(null{$_nocache});";
-                    $_output .= "if (\$_smarty_tpl->tpl_vars[" . $parameter['if condition']['var'] . "]->value = " . $parameter['if condition']['value'] . ") {?>";
+                    $_output = "<?php  } else { if (!isset(\$_smarty_tpl->tpl_vars[" .
+                        $parameter['if condition']['var'] . "])) \$_smarty_tpl->tpl_vars[" .
+                        $parameter['if condition']['var'] . "] = new Smarty_Variable(null{$_nocache});";
+                    $_output .= "if (\$_smarty_tpl->tpl_vars[" . $parameter['if condition']['var'] . "]->value = " .
+                        $parameter['if condition']['value'] . ") {?>";
                 }
 
                 return $_output;
@@ -155,22 +184,35 @@
         } else {
             $tmp = '';
             foreach ($compiler->prefix_code as $code) {
-                $tmp .= $code;
+                $tmp = $compiler->appendCode($tmp, $code);
             }
             $compiler->prefix_code = array();
+            $tmp = $compiler->appendCode("<?php } else {?>", $tmp);
             $this->openTag($compiler, 'elseif', array($nesting + 1, $compiler->tag_nocache));
             if ($condition_by_assign) {
                 if (is_array($parameter['if condition']['var'])) {
-                    $_output = "<?php } else {?>{$tmp}<?php  if (!isset(\$_smarty_tpl->tpl_vars[" . $parameter['if condition']['var']['var'] . "]) || !is_array(\$_smarty_tpl->tpl_vars[" . $parameter['if condition']['var']['var'] . "]->value)) \$_smarty_tpl->createLocalArrayVariable(" . $parameter['if condition']['var']['var'] . "$_nocache);\n";
-                    $_output .= "if (\$_smarty_tpl->tpl_vars[" . $parameter['if condition']['var']['var'] . "]->value" . $parameter['if condition']['var']['smarty_internal_index'] . " = " . $parameter['if condition']['value'] . ") {?>";
+                    $_output = $compiler->appendCode($tmp, "<?php  if (!isset(\$_smarty_tpl->tpl_vars[" .
+                                                         $parameter['if condition']['var']['var'] .
+                                                         "]) || !is_array(\$_smarty_tpl->tpl_vars[" .
+                                                         $parameter['if condition']['var']['var'] .
+                                                         "]->value)) \$_smarty_tpl->smarty->ext->_var->createLocalArrayVariable(\$_smarty_tpl, " .
+                                                         $parameter['if condition']['var']['var'] . "$_nocache);\n");
+                    $_output .= "if (\$_smarty_tpl->tpl_vars[" . $parameter['if condition']['var']['var'] . "]->value" .
+                        $parameter['if condition']['var']['smarty_internal_index'] . " = " .
+                        $parameter['if condition']['value'] . ") {?>";
                 } else {
-                    $_output = "<?php } else {?>{$tmp}<?php if (!isset(\$_smarty_tpl->tpl_vars[" . $parameter['if condition']['var'] . "])) \$_smarty_tpl->tpl_vars[" . $parameter['if condition']['var'] . "] = new Smarty_Variable(null{$_nocache});";
-                    $_output .= "if (\$_smarty_tpl->tpl_vars[" . $parameter['if condition']['var'] . "]->value = " . $parameter['if condition']['value'] . ") {?>";
+                    $_output = $compiler->appendCode($tmp, "<?php if (!isset(\$_smarty_tpl->tpl_vars[" .
+                                                         $parameter['if condition']['var'] .
+                                                         "])) \$_smarty_tpl->tpl_vars[" .
+                                                         $parameter['if condition']['var'] .
+                                                         "] = new Smarty_Variable(null{$_nocache});");
+                    $_output .= "if (\$_smarty_tpl->tpl_vars[" . $parameter['if condition']['var'] . "]->value = " .
+                        $parameter['if condition']['value'] . ") {?>";
                 }
 
                 return $_output;
             } else {
-                return "<?php } else {?>{$tmp}<?php if ({$parameter['if condition']}) {?>";
+                return $compiler->appendCode($tmp, "<?php if ({$parameter['if condition']}) {?>");
             }
         }
     }
@@ -187,13 +229,13 @@
     /**
      * Compiles code for the {/if} tag
      *
-     * @param array  $args      array with attributes from parser
+     * @param array                                 $args      array with attributes from parser
-     * @param object $compiler  compiler object
+     * @param \Smarty_Internal_TemplateCompilerBase $compiler  compiler object
-     * @param array  $parameter array with compilation parameter
+     * @param array                                 $parameter array with compilation parameter
      *
      * @return string compiled code
      */
-    public function compile($args, $compiler, $parameter)
+    public function compile($args, Smarty_Internal_TemplateCompilerBase $compiler, $parameter)
     {
         // must endblock be nocache?
         if ($compiler->nocache) {
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_method_registerclass.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_method_registerclass.php	(revision )
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_method_registerclass.php	(revision )
@@ -0,0 +1,46 @@
+<?php
+
+/**
+ * Smarty Method RegisterClass
+ *
+ * Smarty::registerClass() method
+ *
+ * @package    Smarty
+ * @subpackage PluginsInternal
+ * @author     Uwe Tews
+ */
+class Smarty_Internal_Method_RegisterClass
+{
+    /**
+     * Valid for Smarty and template object
+     *
+     * @var int
+     */
+    public $objMap = 3;
+
+    /**
+     * Registers static classes to be used in templates
+     *
+     * @api  Smarty::registerClass()
+     * @link http://www.smarty.net/docs/en/api.register.class.tpl
+     *
+     * @param \Smarty_Internal_TemplateBase|\Smarty_Internal_Template|\Smarty $obj
+     * @param  string                                                         $class_name
+     * @param  string                                                         $class_impl the referenced PHP class to
+     *                                                                                    register
+     *
+     * @return \Smarty|\Smarty_Internal_Template
+     * @throws \SmartyException
+     */
+    public function registerClass(Smarty_Internal_TemplateBase $obj, $class_name, $class_impl)
+    {
+        $smarty = isset($obj->smarty) ? $obj->smarty : $obj;
+        // test if exists
+        if (!class_exists($class_impl)) {
+            throw new SmartyException("Undefined class '$class_impl' in register template class");
+        }
+        // register the class
+        $smarty->registered_classes[$class_name] = $class_impl;
+        return $obj;
+    }
+}
\ No newline at end of file
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_compile_private_object_function.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_compile_private_object_function.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_compile_private_object_function.php	(revision )
@@ -27,15 +27,15 @@
     /**
      * Compiles code for the execution of function plugin
      *
-     * @param  array  $args      array with attributes from parser
+     * @param  array                                       $args      array with attributes from parser
-     * @param  object $compiler  compiler object
+     * @param \Smarty_Internal_TemplateCompilerBase $compiler  compiler object
-     * @param  array  $parameter array with compilation parameter
+     * @param  array                                       $parameter array with compilation parameter
-     * @param  string $tag       name of function
+     * @param  string                                      $tag       name of function
-     * @param  string $method    name of method to call
+     * @param  string                                      $method    name of method to call
      *
      * @return string compiled code
      */
-    public function compile($args, $compiler, $parameter, $tag, $method)
+    public function compile($args, Smarty_Internal_TemplateCompilerBase $compiler, $parameter, $tag, $method)
     {
         // check and get attributes
         $_attr = $this->getAttributes($compiler, $args);
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_compile_private_special_variable.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_compile_private_special_variable.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_compile_private_special_variable.php	(revision )
@@ -19,96 +19,108 @@
     /**
      * Compiles code for the special $smarty variables
      *
-     * @param  array  $args     array with attributes from parser
+     * @param  array                                       $args     array with attributes from parser
-     * @param  object $compiler compiler object
+     * @param \Smarty_Internal_TemplateCompilerBase        $compiler compiler object
-     * @param         $parameter
+     * @param                                              $parameter
      *
      * @return string compiled code
+     * @throws \SmartyCompilerException
      */
-    public function compile($args, $compiler, $parameter)
+    public function compile($args, Smarty_Internal_TemplateCompilerBase $compiler, $parameter)
     {
         $_index = preg_split("/\]\[/", substr($parameter, 1, strlen($parameter) - 2));
-        $compiled_ref = ' ';
-        $variable = trim($_index[0], "'");
+        $variable = strtolower($compiler->getId($_index[ 0 ]));
+        if ($variable === false) {
+            $compiler->trigger_template_error("special \$Smarty variable name index can not be variable", null, true);
+        }
+        if (!isset($compiler->smarty->security_policy) ||
+            $compiler->smarty->security_policy->isTrustedSpecialSmartyVar($variable, $compiler)
+        ) {
-        switch ($variable) {
-            case 'foreach':
+            switch ($variable) {
+                case 'foreach':
-                return "\$_smarty_tpl->getVariable('smarty')->value$parameter";
-            case 'section':
+                case 'section':
-                return "\$_smarty_tpl->getVariable('smarty')->value$parameter";
+                    if (!isset($compiler->_tag_objects[ $variable ])) {
+                        $class = 'Smarty_Internal_Compile_' . ucfirst($variable);
+                        $compiler->_tag_objects[ $variable ] = new $class;
+                    }
+                    return $compiler->_tag_objects[ $variable ]->compileSpecialVariable(array(), $compiler, $_index);
-            case 'capture':
+                case 'capture':
-                return "Smarty::\$_smarty_vars$parameter";
+                    if (class_exists('Smarty_Internal_Compile_Capture')) {
+                        return Smarty_Internal_Compile_Capture::compileSpecialVariable(array(), $compiler, $_index);
+                    }
+                    return '';
-            case 'now':
-                return 'time()';
-            case 'cookies':
+                case 'now':
+                    return 'time()';
+                case 'cookies':
-                if (isset($compiler->smarty->security_policy) && !$compiler->smarty->security_policy->allow_super_globals) {
+                    if (isset($compiler->smarty->security_policy) &&
+                        !$compiler->smarty->security_policy->allow_super_globals
+                    ) {
-                    $compiler->trigger_template_error("(secure mode) super globals not permitted");
-                    break;
-                }
-                $compiled_ref = '$_COOKIE';
-                break;
+                        $compiler->trigger_template_error("(secure mode) super globals not permitted");
+                        break;
+                    }
+                    $compiled_ref = '$_COOKIE';
+                    break;
-
-            case 'get':
-            case 'post':
-            case 'env':
-            case 'server':
-            case 'session':
-            case 'request':
+                case 'get':
+                case 'post':
+                case 'env':
+                case 'server':
+                case 'session':
+                case 'request':
-                if (isset($compiler->smarty->security_policy) && !$compiler->smarty->security_policy->allow_super_globals) {
+                    if (isset($compiler->smarty->security_policy) &&
+                        !$compiler->smarty->security_policy->allow_super_globals
+                    ) {
-                    $compiler->trigger_template_error("(secure mode) super globals not permitted");
-                    break;
-                }
-                $compiled_ref = '$_' . strtoupper($variable);
-                break;
+                        $compiler->trigger_template_error("(secure mode) super globals not permitted");
+                        break;
+                    }
+                    $compiled_ref = '$_' . strtoupper($variable);
+                    break;
 
-            case 'template':
-                return 'basename($_smarty_tpl->source->filepath)';
+                case 'template':
+                    return 'basename($_smarty_tpl->source->filepath)';
 
-            case 'template_object':
-                return '$_smarty_tpl';
+                case 'template_object':
+                    return '$_smarty_tpl';
 
-            case 'current_dir':
-                return 'dirname($_smarty_tpl->source->filepath)';
+                case 'current_dir':
+                    return 'dirname($_smarty_tpl->source->filepath)';
 
-            case 'version':
+                case 'version':
-                $_version = Smarty::SMARTY_VERSION;
+                     return "Smarty::SMARTY_VERSION";
 
-                return "'$_version'";
-
-            case 'const':
+                case 'const':
-                if (isset($compiler->smarty->security_policy) && !$compiler->smarty->security_policy->allow_constants) {
+                    if (isset($compiler->smarty->security_policy) &&
+                        !$compiler->smarty->security_policy->allow_constants
+                    ) {
-                    $compiler->trigger_template_error("(secure mode) constants not permitted");
-                    break;
-                }
+                        $compiler->trigger_template_error("(secure mode) constants not permitted");
+                        break;
+                    }
-
+                    if (strpos($_index[ 1 ], '$') === false && strpos($_index[ 1 ], '\'') === false) {
+                        return "@constant('{$_index[1]}')";
+                    } else {
-                return "@constant({$_index[1]})";
+                        return "@constant({$_index[1]})";
+                    }
 
-            case 'config':
+                case 'config':
-                if (isset($_index[2])) {
+                    if (isset($_index[ 2 ])) {
-                    return "(is_array(\$tmp = \$_smarty_tpl->getConfigVariable($_index[1])) ? \$tmp[$_index[2]] : null)";
+                        return "(is_array(\$tmp = \$_smarty_tpl->smarty->ext->configload->_getConfigVariable(\$_smarty_tpl, $_index[1])) ? \$tmp[$_index[2]] : null)";
-                } else {
+                    } else {
-                    return "\$_smarty_tpl->getConfigVariable($_index[1])";
+                        return "\$_smarty_tpl->smarty->ext->configload->_getConfigVariable(\$_smarty_tpl, $_index[1])";
-                }
-            case 'ldelim':
+                    }
+                case 'ldelim':
-                $_ldelim = $compiler->smarty->left_delimiter;
-
-                return "'$_ldelim'";
-
+                    return "\$_smarty_tpl->smarty->left_delimiter";
-            case 'rdelim':
+                case 'rdelim':
-                $_rdelim = $compiler->smarty->right_delimiter;
-
-                return "'$_rdelim'";
-
+                    return "\$_smarty_tpl->smarty->right_delimiter";
-            default:
+                default:
-                $compiler->trigger_template_error('$smarty.' . trim($_index[0], "'") . ' is invalid');
+                    $compiler->trigger_template_error('$smarty.' . trim($_index[ 0 ], "'") . ' is not defined');
-                break;
-        }
+                    break;
+            }
-        if (isset($_index[1])) {
+            if (isset($_index[ 1 ])) {
-            array_shift($_index);
-            foreach ($_index as $_ind) {
-                $compiled_ref = $compiled_ref . "[$_ind]";
-            }
-        }
+                array_shift($_index);
+                foreach ($_index as $_ind) {
+                    $compiled_ref = $compiled_ref . "[$_ind]";
+                }
+            }
-
-        return $compiled_ref;
+            return $compiled_ref;
+        }
     }
 }
Index: src/includes/classes/Smarty/plugins/modifiercompiler.indent.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/plugins/modifiercompiler.indent.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/plugins/modifiercompiler.indent.php	(revision )
@@ -1,0 +1,0 @@
